# pylint: disable=R0902
# pylint: disable=W0232
# pylint: disable=C0325
# pylint: disable=W0232
# pylint: disable=E0611
# pylint: disable=E1101
""" Module for Managing switch system information printout
"""

from netshowlib.cumulus.system_summary import SystemSummary
from netshow.linux import show_system as linux_system


class ShowSystem(linux_system.ShowSystem):
    """
    Class responsible for printing out basic switch summary info
    for the cumulus provider
    """
    def __init__(self, cl):
        self.use_json = cl.get('--json') or cl.get('-j')
        self.system = SystemSummary()

    def cli_output(self):
        """
        :return: print out system info on a cumulus switch
        """

        _pd = self.system.platform_info
        # If platform detect does not work.
        # TODO make this better....
        if not _pd:
            return linux_system.ShowSystem.cli_output(self)

        chip = _pd.get('soc')
        cpu = _pd.get('cpu')
        _str = ''
        _str = "\n%s %s\n" % (_pd.get('vendor'), _pd.get('model_name'))
        _str += "%s %s %s\n" % (self.system.os_name, 'Version',
                                self.system.version)
        _str += "%s: %s\n\n" % ('Build', self.system.os_build)
        _str += "%s: %s %s %s\n\n" % ('Chipset',
                                      chip.get('vendor'),
                                      chip.get('model'),
                                      chip.get('model_id'))
        _str += "%s: %s\n\n" % ('Port Config', _pd.get('ports').get('layout'))
        _str += "%s: (%s) %s %s %s %s\n\n" % ('CPU',
                                              self.system.arch,
                                              cpu.get('vendor'),
                                              cpu.get('model'),
                                              cpu.get('model_id'),
                                              cpu.get('speed'))
        _str += "%s: %s\n" % ('Uptime', self.uptime)
        return _str
